import { EditorSelection, Text, Extension } from '@codemirror/state';
import { DecorationSet } from '@codemirror/view';

type Connection = <T extends object, R>(value: T) => Promise<R>;

type Presence = {
    selection: EditorSelection;
    clientID: string;
};

type ClientOptions = {
    /** An RPC connection that should send JSON messages to the server. */
    readonly connection: Connection;
    readonly clientID?: string;
    readonly presenceInterval?: number;
    readonly presenceExpiry?: number;
    readonly presenceDecorations?: (presences: Presence[]) => DecorationSet;
};
declare class CollabClient {
    readonly initialDoc: Text;
    readonly extension: Extension;
    readonly presence: Extension;
    private constructor();
    static of(options: ClientOptions): Promise<CollabClient>;
}

export { ClientOptions, CollabClient, Connection, Presence };
